(****************************************************************************)
(*                                                                          *)
(*  Unit     : UMOUSE.PAS                                                   *)
(*  Zweck    : Einbindung der Mausfunktionen in Turbopascal (Version 1.4)   *)
(*                                                                          *)
(*  Sprache             : Borland Pascal 7.0                                *)
(*  erstellt            : 1.Oktober 1996                                    *)
(*  letzte Modifikation : 21.Januar 1997                                    *)
(*                                                                          *)
(*  (W) Written by Martin Stigge                                            *)
(*  (C) Copyright 1996 by StiggeBrothers                                    *)
(*                                                                          *)
(****************************************************************************)

unit umouse;

interface

type
  mt_grcursormap=record
                 mask:array[0..1,0..15] of word;
                 hotspot:record
                           x,y:integer;
                         end;
               end;

const
  munit_ver='1.4';
  mtyp_ibm:byte=0;
  mtyp_bus:byte=1;
  mtyp_seriell:byte=2;
  mtyp_inport:byte=3;
  mtyp_ps2:byte=4;
  mtyp_hp:byte=5;
  mtyp_strings:array[0..5]of string[20]=
                 ('IBM-Maus','Bus-Maus','Serielle Maus',
                  'InPort-Maus','PS/2-Maus','Hewlett Packard Maus');
  m_l:word=1;
  m_r:word=2;
  m_m:word=4;
  m_lr:word=3;
  m_lm:word=5;
  m_mr:word=6;
  m_rm:word=6;
  m_lrm:word=7;
  m_lmr:word=7;
  m_all:word=7;
  me_moved:word=1 shl 0;
  me_leftpressed:word=1 shl 1;
  me_leftreleased:word=1 shl 2;
  me_rightpressed:word=1 shl 3;
  me_rightreleased:word=1 shl 4;
  me_middlepressed:word=1 shl 5;
  me_middlereleased:word=1 shl 6;
  ml_l:word=0;
  ml_r:word=1;
  ml_m:word=2;

function m_reset:boolean;                                (* Initialisiert den Maustreiber; TRUE, wenn Reset erfolgreich war *)
function m_ok:boolean;                                   (* TRUE, wenn Maus zur Verfgung steht (=Reset erfolgreich war) *)
function m_buttons:word;                                 (* Liefert die Anzahl der Maus-Tasten zurck *)
function m_type:byte;                                    (* Liefert den Maustyp *)
procedure m_cursoron;                                    (* Macht den Maus-Cursor sichtbar *)
procedure m_cursoroff;                                   (* Macht den Maus-Cursor unsichtbar *)
function m_xpos:word;                                    (* Liefert die aktuelle X-Position im Textmodus *)
function m_ypos:word;                                    (* Liefert die aktuelle Y-Position im Textmodus *)
function m_xpixelpos:word;                               (* Liefert die aktuelle X-Pos. im Grafikmodus *)
function m_ypixelpos:word;                               (* Liefert die aktuelle Y-Pos. im Grafikmodus *)
function m_buttonpr:boolean;                             (* TRUE, wenn Mausbutton gedrckt wurde *)
function m_pressed(button:word):boolean;                 (* TRUE, wenn angegebener Button gedrckt wurde *)
procedure m_cursorto(x,y:word);                          (* Setzt den Cursor an die angegebene Position *)
procedure m_textcursorto(x,y:word);                      (* Setzt im Textmodus den Cursor an die angegebene Position *)
procedure m_cursorrange(xmin,ymin,xmax,ymax:word);       (* Setzt den Bewegungsbereich des Mauscursors *)
procedure m_textcursorrange(xmin,ymin,xmax,ymax:word);   (* Setzt im Textmodus den Bewegungsbereich des Mauscursors *)
procedure m_grcursordefine(shape:mt_grcursormap);        (* Definiert einen neuen Mauscursor *)
procedure m_textcursordefine(screenmask,cursormask:word);(* Definiert im Textmodus einen neuen Mauscursor *)
function m_xmotion:integer;                              (* Liefert in x die Cursorbewegung (in Mickeys) seit letztem Aufruf *)
function m_ymotion:integer;                              (* Liefert in y die Cursorbewegung (in Mickeys) seit letztem Aufruf *)
procedure m_setprocevent(me:word;callproc:pointer);      (* Setzt den automatischen Aufruf von "callproc" bei dem "me"-Event *)
function m_lastbuttonpressed(button:word):boolean;       (* TRUE, wenn als letzter Button "button" gedrckt wurde [ml_* !] *)


implementation
var
  mtmp_buttons:word;
  mtmp_cursoronoff:boolean;
  mtmp_type:byte;
  mtmp_ok:boolean;
  mtmp_xmotion:integer;
  mtmp_ymotion:integer;


function m_reset:boolean;assembler;
asm
        xor     ax,ax
        int     033h
        mov     mtmp_buttons,bx
        cmp     ax,0FFFFh
        jne     @no_rst
        mov     ax,00024h
        int     033h
        mov     mtmp_type,ch
        mov     mtmp_cursoronoff,0
        mov     mtmp_xmotion,0
        mov     mtmp_ymotion,0
        mov     mtmp_ok,TRUE
        mov     ax,00001h
        jmp     @end
@no_rst:xor     ax,ax
@end:
end;

function m_ok:boolean;assembler;
asm
        mov     al,mtmp_ok
end;

function m_buttons:word;assembler;
asm
        mov     ax,mtmp_buttons
end;

function m_type:byte;assembler;
asm
        mov     al,mtmp_type
end;

procedure m_cursoron;assembler;
asm
        cmp     mtmp_cursoronoff,0
        jne     @end
        mov     ax,1
        int     033h
        mov     mtmp_cursoronoff,1
@end:
end;

procedure m_cursoroff;assembler;
asm
        cmp     mtmp_cursoronoff,1
        jne     @end
        mov     ax,2
        int     033h
        mov     mtmp_cursoronoff,0
@end:
end;

function m_xpos:word;assembler;
asm
        mov     ax,3
        int     033h
        mov     ax,cx
        shr     ax,3
end;

function m_ypos:word;assembler;
asm
        mov     ax,3
        int     033h
        mov     ax,dx
        shr     ax,3
end;

function m_xpixelpos:word;assembler;
asm
        mov     ax,3
        int     033h
        mov     ax,cx
        cmp     mtmp_type,2
        jne     @end
@end:
end;

function m_ypixelpos:word;assembler;
asm
        mov     ax,3
        int     033h
        mov     ax,dx
end;

function m_buttonpr:boolean;assembler;
asm
        mov     ax,3
        int     033h
        xor     ax,ax
        cmp     bx,0
        je      @end
        mov     ax,1
@end:
end;

function m_pressed(button:word):boolean;assembler;
asm
        mov     ax,3
        int     033h
        xor     ax,ax
        cmp     bx,button
        jne     @end
        mov     ax,1
@end:
end;

procedure m_cursorto(x,y:word);assembler;
asm
        mov     ax,4
        mov     cx,x
        shl     cx,1
        mov     dx,y
        int     033h
end;

procedure m_textcursorto(x,y:word);assembler;
asm
        mov     ax,4
        mov     cx,x
        shl     cx,3
        mov     dx,y
        shl     dx,3
        int     033h
end;

procedure m_cursorrange(xmin,ymin,xmax,ymax:word);assembler;
asm
        mov     ax,7
        mov     cx,xmin
        cmp     mtmp_type,2
        jne     @ser1
        shl     cx,1
@ser1:  mov     dx,xmax
        cmp     mtmp_type,2
        jne     @ser2
        shl     dx,1
@ser2:  int     033h
        inc     ax
        mov     cx,ymin
        mov     dx,ymax
        int     033h
end;

procedure m_textcursorrange(xmin,ymin,xmax,ymax:word);assembler;
asm
        mov     ax,7
        mov     cx,xmin
        shl     cx,3
        mov     dx,xmax
        shl     dx,3
        int     033h
        inc     ax
        mov     cx,ymin
        shl     cx,3
        mov     dx,ymax
        shl     dx,3
        int     033h
end;

procedure m_grcursordefine(shape:mt_grcursormap);assembler;
asm
        push    es
        call    m_cursoroff
        mov     ax,9
        les     di,shape
        mov     bx,es:mt_grcursormap[di].hotspot.x
        mov     cx,es:mt_grcursormap[di].hotspot.y
        mov     dx,di
        int     033h
        call    m_cursoron
        pop     es
end;

procedure m_textcursordefine(screenmask,cursormask:word);assembler;
asm
        push    es
        call    m_cursoroff
        mov     ax,0000Ah
        mov     bx,0
        mov     cx,screenmask
        mov     dx,cursormask
        int     033h
        call    m_cursoron
        pop     es
end;

function m_xmotion:integer;assembler;
asm
        mov     ax,11
        int     033h
        mov     ax,cx
        cmp     mtmp_xmotion,0
        je      @end
        add     ax,mtmp_xmotion
@end:   mov     mtmp_ymotion,dx
end;

function m_ymotion:integer;assembler;
asm
        mov     ax,11
        int     033h
        mov     ax,dx
        cmp     mtmp_ymotion,0
        je      @end
        add     ax,mtmp_ymotion
@end:   mov     mtmp_xmotion,cx
end;

procedure m_setprocevent(me:word;callproc:pointer);assembler;
asm
        push    es
        les     di,callproc
        mov     ax,12
        mov     cx,me
        mov     dx,di
        int     033h
        pop     es
end;

function m_lastbuttonpressed(button:word):boolean;assembler;
asm
        mov     ax,5
        mov     bx,button
        int     033h
        or      bx,bx
        jz      @np
        mov     ax,1
        jmp     @end
@np:    xor     ax,ax
@end:
end;


begin
  mtmp_ok:=FALSE;
end.